class Public::TalentReleasesController < Public::BaseController
  include CreateReleasableJobs
  before_action :set_account, :set_project, :set_contract_template

  def new
    @talent_release = build_talent_release
  end

  def create
    @talent_release = build_talent_release(talent_release_params_with_locale_and_contract_template)

    if @talent_release.save(context: :native)
      log_create_analytics
      after_create(@talent_release)
    else
      render :new
    end
  end

  private

  def set_project
    @project = @account.projects.find(params[:project_id])
  end

  def set_account
    @account = Account.find_by(slug: params[:account_id])
  end

  def set_contract_template
    @contract_template = @project.contract_templates.find(params[:contract_template_id])
  end

  def talent_releases
    policy_scope(@project.talent_releases)
  end

  def build_talent_release(params = {})
    authorize talent_releases.build(params)
  end

  def talent_release_params
    params
      .require(:talent_release)
      .permit(
        person_params,
        guardian_params,
        :signature_base64,
        :locale,
        :contract_template,
        photos: [],
      )
  end

  def person_params
    [
      :person_first_name,
      :person_last_name,
      :person_phone,
      :person_email,
      :person_address_street1,
      :person_address_street2,
      :person_address_city,
      :person_address_state,
      :person_address_zip,
      :person_address_country,
    ]
  end

  def guardian_params
    [
      :guardian_first_name,
      :guardian_last_name,
      :guardian_phone,
      :guardian_email,
      :minor,
      :guardian_address_street1,
      :guardian_address_street2,
      :guardian_address_city,
      :guardian_address_state,
      :guardian_address_zip,
      :guardian_address_country,
      :guardian_photo,
    ]
  end

  def talent_release_params_with_locale
    talent_release_params.merge(locale: I18n.locale)
  end

  def talent_release_params_with_locale_and_contract_template
    talent_release_params_with_locale.merge(contract_template: @contract_template)
  end

  def log_create_analytics
    TrackAnalyticsJob.perform_later(nil, nil, :track_create_native_release, release_type: TalentRelease.to_s, account: @account, user_agent: request.user_agent, user_ip: request.remote_ip)
  end
end
